import { useRef, useEffect } from "react";
/* global google */

export default (map, onMove) => {
  const marker = useRef(null);
  useEffect(() => {
    const listener = map.current.addListener("click", ({ latLng }) => {
      if (marker.current) {
        marker.current.setMap(null);
      }
      marker.current = new google.maps.Marker({ map: map.current, position: latLng });
      onMove({ lat: latLng.lat(), lng: latLng.lng() });
    });

    return () => { google.maps.event.removeListener(listener); }
  }, [map, onMove]);
}
