import React from "react";
import styled from "styled-components";
import Input from "./Input";
import { playerNameStore } from "../../domain/store";
import useObservable from "../../hooks/useObservable";

const Container = styled.div`
  display: flex;
  flex-flow: column nowrap;
  justify-content: center;
  align-items: center;
`

const Label = styled.span`
  padding: 0.2em;
`

const FormInput = styled(Input)`
  padding: 0.5em;
`

export default () => {
  const playerName = useObservable(playerNameStore)
  
  return (
    <Container>
      <Label>Player Name</Label>
      <FormInput
        type="text" 
        value={playerName || ""} 
        onChange={({ target }) => playerNameStore.set(target.value)} 
      />
    </Container>
  )
};
