const createObservable = initial => {
  return {
    _get: () => initial, // TODO
    _set: () => {}, // TODO
  }
}

const nameToHookName = name => "use" + name.chatAt(0).toUpperCase() + name.slice(1);

const createHook = obs => {
  // allow linters to pick this up as a hook
  const useObservable = () => {
    // TODO
  }
  return useObservable;
}

export const createStore = (initial, actions = {}) => {
  const store = {}; // maps keys to observables
  const hooks = {};

  const mergeState = newState => {
    Object.entries(newState).forEach(([key, newValue]) => {
      const obs = store[key];
      if (obs) {
        obs._set(newValue);
      } else {
        const newObs = createObservable(newValue);
        store[key] = newObs;
        hooks[nameToHookName(key)] = createHook(newObs);
      }
    });
  };

  mergeState(initial);

  const dispatch = Object.fromEntries(Object.entries(actions).map(([name, action]) => [name, (...args) => mergeState(action(...args))]));

  const selector = Object.fromEntries(Object.entries(store).map(([key, obs]) => [key, obs._get]));

  return [hooks, dispatch, selector];
}